Subject: Re: [PATCH net] net: Allow flow dissector to handle non 4-byte aligned headers

From: Sowmini Varadhan <[email-masked]>
Date: Mon, 1 Feb 2016 11:01:30 -0500

On (02/01/16 16:20), Nicolas Dichtel wrote:
> There is also the tile architecture, up to 76 cores on the board I've seen. It
> requires an alignment on 8!
> I wonder how this case may be properly handled. A simple ipip scenario fails.

Yes, I'm also observing the same thing. Simply setting up gretap like this
results in

# ip link add gretap2 type gretap local myaddr remote hisaddr
# ifconfig gretap2 up

Kernel unaligned access at TPC[969d88] iptunnel_xmit+0xa4/0x1c0
Kernel unaligned access at TPC[969db0] iptunnel_xmit+0xcc/0x1c0
Kernel unaligned access at TPC[969dc4] iptunnel_xmit+0xe0/0x1c0
Kernel unaligned access at TPC[969dc8] iptunnel_xmit+0xe4/0x1c0
Kernel unaligned access at TPC[9191fc] __ip_select_ident+0x80/0x13c

and afacit, the unaligned ip header is triggered by an inner ipv6 packet
that is usually coming from mld or dad.

(and fwiw, the basic iperf/ipv6 test is fine with Tom's patch, need
to try out some of the other permutations without rps etc)